# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ClusterOptionalRestrictions(BaseModel):
    """
    Optional resctrictions applied to sequences before clustering. Includes: * Matching V Gene * Matching J Gene * Matching CDR3 Amino Acids Length
    """ # noqa: E501
    should_match_v_gene: Optional[StrictBool] = Field(default=False, description="Only Sequences with the same V Gene will be clustered together")
    should_match_j_gene: Optional[StrictBool] = Field(default=False, description="Only Sequences with the same J Gene will be clustered together")
    should_match_cdr3_length: Optional[StrictBool] = Field(default=False, description="Only Sequences with the same CDR3 Amino Acid Length will be clustered together")
    __properties: ClassVar[List[str]] = ["should_match_v_gene", "should_match_j_gene", "should_match_cdr3_length"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ClusterOptionalRestrictions from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if should_match_v_gene (nullable) is None
        # and model_fields_set contains the field
        if self.should_match_v_gene is None and "should_match_v_gene" in self.model_fields_set:
            _dict['should_match_v_gene'] = None

        # set to None if should_match_j_gene (nullable) is None
        # and model_fields_set contains the field
        if self.should_match_j_gene is None and "should_match_j_gene" in self.model_fields_set:
            _dict['should_match_j_gene'] = None

        # set to None if should_match_cdr3_length (nullable) is None
        # and model_fields_set contains the field
        if self.should_match_cdr3_length is None and "should_match_cdr3_length" in self.model_fields_set:
            _dict['should_match_cdr3_length'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ClusterOptionalRestrictions from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "should_match_v_gene": obj.get("should_match_v_gene") if obj.get("should_match_v_gene") is not None else False,
            "should_match_j_gene": obj.get("should_match_j_gene") if obj.get("should_match_j_gene") is not None else False,
            "should_match_cdr3_length": obj.get("should_match_cdr3_length") if obj.get("should_match_cdr3_length") is not None else False
        })
        return _obj


