# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, StrictFloat, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Union
from igx_api.l1.openapi_client.models.get_ml_invocation_stats_response_body_stats_inner_last_invoked_at import GetMlInvocationStatsResponseBodyStatsInnerLastInvokedAt
from typing import Optional, Set
from typing_extensions import Self

class GetMlInvocationStatsResponseBodyStatsInner(BaseModel):
    """
    GetMlInvocationStatsResponseBodyStatsInner
    """ # noqa: E501
    endpoint_id: StrictStr
    display_name: StrictStr
    total_invocations: StrictInt
    success_ratio: Union[StrictFloat, StrictInt]
    last_invoked_at: GetMlInvocationStatsResponseBodyStatsInnerLastInvokedAt
    invocations_last_24h: StrictInt
    invocations_last_7d: StrictInt
    invocations_last_1m: StrictInt
    __properties: ClassVar[List[str]] = ["endpoint_id", "display_name", "total_invocations", "success_ratio", "last_invoked_at", "invocations_last_24h", "invocations_last_7d", "invocations_last_1m"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of GetMlInvocationStatsResponseBodyStatsInner from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of last_invoked_at
        if self.last_invoked_at:
            _dict['last_invoked_at'] = self.last_invoked_at.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of GetMlInvocationStatsResponseBodyStatsInner from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "endpoint_id": obj.get("endpoint_id"),
            "display_name": obj.get("display_name"),
            "total_invocations": obj.get("total_invocations"),
            "success_ratio": obj.get("success_ratio"),
            "last_invoked_at": GetMlInvocationStatsResponseBodyStatsInnerLastInvokedAt.from_dict(obj["last_invoked_at"]) if obj.get("last_invoked_at") is not None else None,
            "invocations_last_24h": obj.get("invocations_last_24h"),
            "invocations_last_7d": obj.get("invocations_last_7d"),
            "invocations_last_1m": obj.get("invocations_last_1m")
        })
        return _obj


