# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ImportCollectionRequest(BaseModel):
    """
    ImportCollectionRequest
    """ # noqa: E501
    file_id: StrictStr = Field(description="The unique identifier of a file.")
    organism: Optional[StrictStr] = Field(default=None, description="Name of the organism from which the imported data originates, used for running optional reference configuration validation before a collection import job is started.")
    reference_database_id: Optional[StrictStr] = Field(default=None, description="Unique Identifier of a reference database. If this is not provided, IGX will select the only one possible reference available for this import job or throw an error if there's more than one references available.")
    reference_database_version: Optional[StrictInt] = Field(default=None, description="Reference database revision version. If this is not provided, IGX will select the only one possible reference available for this import job or throw an error if there's more than one references available.")
    __properties: ClassVar[List[str]] = ["file_id", "organism", "reference_database_id", "reference_database_version"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ImportCollectionRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if organism (nullable) is None
        # and model_fields_set contains the field
        if self.organism is None and "organism" in self.model_fields_set:
            _dict['organism'] = None

        # set to None if reference_database_id (nullable) is None
        # and model_fields_set contains the field
        if self.reference_database_id is None and "reference_database_id" in self.model_fields_set:
            _dict['reference_database_id'] = None

        # set to None if reference_database_version (nullable) is None
        # and model_fields_set contains the field
        if self.reference_database_version is None and "reference_database_version" in self.model_fields_set:
            _dict['reference_database_version'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ImportCollectionRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "file_id": obj.get("file_id"),
            "organism": obj.get("organism"),
            "reference_database_id": obj.get("reference_database_id"),
            "reference_database_version": obj.get("reference_database_version")
        })
        return _obj


