# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class LiabilitiesWork(BaseModel):
    """
     Set of IDs based on which clones will be resolved and then passed for liabilities computation.
    """ # noqa: E501
    clone_ids: Optional[List[StrictStr]] = Field(default=None, description="Identifiers of clones that will be passed for liabilities computation.")
    sequence_ids: Optional[List[StrictInt]] = Field(default=None, description="Identifiers of sequences that will be passed for liabilities computation.")
    __properties: ClassVar[List[str]] = ["clone_ids", "sequence_ids"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of LiabilitiesWork from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if clone_ids (nullable) is None
        # and model_fields_set contains the field
        if self.clone_ids is None and "clone_ids" in self.model_fields_set:
            _dict['clone_ids'] = None

        # set to None if sequence_ids (nullable) is None
        # and model_fields_set contains the field
        if self.sequence_ids is None and "sequence_ids" in self.model_fields_set:
            _dict['sequence_ids'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of LiabilitiesWork from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "clone_ids": obj.get("clone_ids"),
            "sequence_ids": obj.get("sequence_ids")
        })
        return _obj


