# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from igx_api.l1.openapi_client.models.join_operation_inputs_inputs_inner import JoinOperationInputsInputsInner
from igx_api.l1.openapi_client.models.set_operation_input import SetOperationInput
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

NULLISHTRACKTEMPLATENODEINPUT_ONE_OF_SCHEMAS = ["JoinOperationInputsInputsInner", "SetOperationInput"]

class NullishTrackTemplateNodeInput(BaseModel):
    """
    Input identifier for annotation or set operation input
    """
    # data type: SetOperationInput
    oneof_schema_1_validator: Optional[SetOperationInput] = None
    # data type: JoinOperationInputsInputsInner
    oneof_schema_2_validator: Optional[JoinOperationInputsInputsInner] = None
    actual_instance: Optional[Union[JoinOperationInputsInputsInner, SetOperationInput]] = None
    one_of_schemas: Set[str] = { "JoinOperationInputsInputsInner", "SetOperationInput" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        if v is None:
            return v

        instance = NullishTrackTemplateNodeInput.model_construct()
        error_messages = []
        match = 0
        # validate data type: SetOperationInput
        if not isinstance(v, SetOperationInput):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SetOperationInput`")
        else:
            match += 1
        # validate data type: JoinOperationInputsInputsInner
        if not isinstance(v, JoinOperationInputsInputsInner):
            error_messages.append(f"Error! Input type `{type(v)}` is not `JoinOperationInputsInputsInner`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in NullishTrackTemplateNodeInput with oneOf schemas: JoinOperationInputsInputsInner, SetOperationInput. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in NullishTrackTemplateNodeInput with oneOf schemas: JoinOperationInputsInputsInner, SetOperationInput. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: Optional[str]) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        if json_str is None:
            return instance

        error_messages = []
        match = 0

        # deserialize data into SetOperationInput
        try:
            instance.actual_instance = SetOperationInput.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into JoinOperationInputsInputsInner
        try:
            instance.actual_instance = JoinOperationInputsInputsInner.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into NullishTrackTemplateNodeInput with oneOf schemas: JoinOperationInputsInputsInner, SetOperationInput. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into NullishTrackTemplateNodeInput with oneOf schemas: JoinOperationInputsInputsInner, SetOperationInput. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], JoinOperationInputsInputsInner, SetOperationInput]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


