# coding: utf-8

"""
    IGX Platform Public API

    The IGX Platform Public API is a powerful API that enables a wide variety of use cases.                 The architecture of the IGX Platform centers around files, collections, tags and analyses,                 securely managed through cloud-based access.                 The Public API can be used to easily import data, annotate metadata, run analyses and export results.

    The version of the OpenAPI document: 1.0.0
    Contact: info@enpicom.com
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import json
import pprint
from pydantic import BaseModel, ConfigDict, Field, StrictStr, ValidationError, field_validator
from typing import Any, List, Optional
from igx_api.l1.openapi_client.models.clone_annotation import CloneAnnotation
from igx_api.l1.openapi_client.models.collection_annotation import CollectionAnnotation
from igx_api.l1.openapi_client.models.sequence_annotation import SequenceAnnotation
from pydantic import StrictStr, Field
from typing import Union, List, Set, Optional, Dict
from typing_extensions import Literal, Self

TEMPLATEDSEARCHANDTAGANNOTATION_ONE_OF_SCHEMAS = ["CloneAnnotation", "CollectionAnnotation", "SequenceAnnotation"]

class TemplatedSearchAndTagAnnotation(BaseModel):
    """
    TemplatedSearchAndTagAnnotation
    """
    # data type: CollectionAnnotation
    oneof_schema_1_validator: Optional[CollectionAnnotation] = None
    # data type: CloneAnnotation
    oneof_schema_2_validator: Optional[CloneAnnotation] = None
    # data type: SequenceAnnotation
    oneof_schema_3_validator: Optional[SequenceAnnotation] = None
    actual_instance: Optional[Union[CloneAnnotation, CollectionAnnotation, SequenceAnnotation]] = None
    one_of_schemas: Set[str] = { "CloneAnnotation", "CollectionAnnotation", "SequenceAnnotation" }

    model_config = ConfigDict(
        validate_assignment=True,
        protected_namespaces=(),
    )


    def __init__(self, *args, **kwargs) -> None:
        if args:
            if len(args) > 1:
                raise ValueError("If a position argument is used, only 1 is allowed to set `actual_instance`")
            if kwargs:
                raise ValueError("If a position argument is used, keyword arguments cannot be used.")
            super().__init__(actual_instance=args[0])
        else:
            super().__init__(**kwargs)

    @field_validator('actual_instance')
    def actual_instance_must_validate_oneof(cls, v):
        instance = TemplatedSearchAndTagAnnotation.model_construct()
        error_messages = []
        match = 0
        # validate data type: CollectionAnnotation
        if not isinstance(v, CollectionAnnotation):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CollectionAnnotation`")
        else:
            match += 1
        # validate data type: CloneAnnotation
        if not isinstance(v, CloneAnnotation):
            error_messages.append(f"Error! Input type `{type(v)}` is not `CloneAnnotation`")
        else:
            match += 1
        # validate data type: SequenceAnnotation
        if not isinstance(v, SequenceAnnotation):
            error_messages.append(f"Error! Input type `{type(v)}` is not `SequenceAnnotation`")
        else:
            match += 1
        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when setting `actual_instance` in TemplatedSearchAndTagAnnotation with oneOf schemas: CloneAnnotation, CollectionAnnotation, SequenceAnnotation. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when setting `actual_instance` in TemplatedSearchAndTagAnnotation with oneOf schemas: CloneAnnotation, CollectionAnnotation, SequenceAnnotation. Details: " + ", ".join(error_messages))
        else:
            return v

    @classmethod
    def from_dict(cls, obj: Union[str, Dict[str, Any]]) -> Self:
        return cls.from_json(json.dumps(obj))

    @classmethod
    def from_json(cls, json_str: str) -> Self:
        """Returns the object represented by the json string"""
        instance = cls.model_construct()
        error_messages = []
        match = 0

        # deserialize data into CollectionAnnotation
        try:
            instance.actual_instance = CollectionAnnotation.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into CloneAnnotation
        try:
            instance.actual_instance = CloneAnnotation.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))
        # deserialize data into SequenceAnnotation
        try:
            instance.actual_instance = SequenceAnnotation.from_json(json_str)
            match += 1
        except (ValidationError, ValueError) as e:
            error_messages.append(str(e))

        if match > 1:
            # more than 1 match
            raise ValueError("Multiple matches found when deserializing the JSON string into TemplatedSearchAndTagAnnotation with oneOf schemas: CloneAnnotation, CollectionAnnotation, SequenceAnnotation. Details: " + ", ".join(error_messages))
        elif match == 0:
            # no match
            raise ValueError("No match found when deserializing the JSON string into TemplatedSearchAndTagAnnotation with oneOf schemas: CloneAnnotation, CollectionAnnotation, SequenceAnnotation. Details: " + ", ".join(error_messages))
        else:
            return instance

    def to_json(self) -> str:
        """Returns the JSON representation of the actual instance"""
        if self.actual_instance is None:
            return "null"

        if hasattr(self.actual_instance, "to_json") and callable(self.actual_instance.to_json):
            return self.actual_instance.to_json()
        else:
            return json.dumps(self.actual_instance)

    def to_dict(self) -> Optional[Union[Dict[str, Any], CloneAnnotation, CollectionAnnotation, SequenceAnnotation]]:
        """Returns the dict representation of the actual instance"""
        if self.actual_instance is None:
            return None

        if hasattr(self.actual_instance, "to_dict") and callable(self.actual_instance.to_dict):
            return self.actual_instance.to_dict()
        else:
            # primitive type
            return self.actual_instance

    def to_str(self) -> str:
        """Returns the string representation of the actual instance"""
        return pprint.pformat(self.model_dump())


